Controller = require './controller'

class Builder
  @plugins = {
    # store_in: {
    #   post_build: (collection_name) ->
    #     @model._collection_name = collection_name
    # }
  }
  
  constructor: (@name) ->
    for field in Object.keys(Builder.plugins)
      do (field) =>
        this[field] = ->
          @properties[field] = Array::slice.call arguments
          this

    @actions = {}
    @before_filters = []
    @mixins = []
    
  extends: (name) ->
    @extends = name
    this
  action: (name, method) ->
    throw new Error('Cannot name an action "execute"') if name is 'execute'
    @actions[name] = method
    this
  mixin: (mixin) ->
    @mixins.push mixin
    this
  initialize: (method) ->
    @initializer = method
    this
  before_filter: (method, options) ->
    @before_filters.push {method: method, options: options}
    this

  build: ->
    # pre-build plugins
    for k, v of @properties
      Builder.plugins[k].pre_build.apply this, v if Builder.plugins[k].pre_build?

    initializer = @initializer
    # @extends
    controller = class extends Controller
      constructor: ->
        super()
        @init()
        initializer.call @
    controller::init = ->
      @_type = controller
    controller._name = @name
    controller._properties = @properties
    controller._before_filters = @before_filters
    for k, v of @actions
      controller::[k] = v
    for m in @mixins
      for k, v of m
        controller::[k] = v
    
    @controller = controller
    # post-build plugins
    for k, v of @properties
      Builder.plugins[k].post_build.apply this, v if Builder.plugins[k].post_build?
    
    @controller

module.exports = Builder
