class Controller
  constructor: ->
  # init: ->
  #   @flash = @session.flash ? {}
  #   delete @session.flash

  execute: (action, callback) ->
    throw new Error "Could not find #{action} in #{@_name}" if not this[action]?
    @_action = action
    @_callback = callback
    
    idx = 0
    next = (err) =>
      return callback(err) if err?
      return @[action]() if idx is @_type._before_filters.length
      filter = @_type._before_filters[idx++]
      
      if filter.options?.only?
        return next() unless action in filter.options.only
      else if filter.options?.except?
        return next() if action in filter.options.except
      
      if typeof filter.method is 'string'
        @[filter.method] next
      else if typeof filter.method is 'function'
        filter.method.call @, next
    next()

  render: (view, data) ->
    @_callback()
    
  error: (err) ->
    @_responder.next err
  unauthorized: ->
    @_responder.unauthorized.apply @_responder, arguments
  # render: (view, data, options) ->
  #   if arguments.length is 0
  #     @_view = @_action
  #     data = this
  #   else if typeof view is 'string'
  #     @_view = view
  #     data ?= this
  #   else
  #     @_view = @_action
  #     options = data
  #     data = view
  #     
  #   @_responder.render this, data, options
  redirect_to: (url, options) ->
    if options?.notice?
      @session.flash ?= {}
      @session.flash.notice = options.notice
    if options?.error?
      @session.flash ?= {}
      @session.flash.error = options.error
    @_responder.redirect_to url
    
  # options: httpOnly, secure, expires, maxAge
  set_cookie: (name, value, options) ->
    @_responder.res.cookie name, value, options
  set_headers: (headers) ->
    @_responder.set_headers {headers: headers}
    
  clear_cookie: (name) ->
    @_responder.res.clearCookie name
    
  stylesheet_link_tag: (filename) ->
    return '<link type="text/css" rel="stylesheet" href="/css/' + filename + '.css">'
    
  link_to: (text, link) ->
    return '<a href="' + link + '">' + text + '</a>'

module.exports = Controller
